.686			
.MMX
.model flat, stdcall
option casemap:none

include j:\masm32\include\windows.inc
include j:\masm32\include\kernel32.inc
include j:\masm32\include\masm32.inc

include j:\masm32\macros\macros.asm
include j:\masm32\macros\timers.asm

includelib j:\masm32\lib\kernel32.lib
includelib j:\masm32\lib\masm32.lib


Main        proto

FJT2 proto
FJT3 proto
FJT4 proto

.data

align 4

  LOOP_COUNT    EQU	500000
  MINUS_1       EQU 0ffffffffH

  SzBMI1         db "FJT2 Cresta/IanB, byte-length shifts:  ",0
  SzBMI2         db "FJT3 Cresta/IanB, word-length shifts:  ",0
  SzBMI3         db "FJT4 Cresta/IanB, dword-length shifts: ",0

  ; matchlen 10, sourcelen 50
  ; with optimisations, the Boyer-Moore is now only half as slow as the
  ; word scanner for short searches
  SzMatch1       db "Here it is"
  SzTest1        db "Short test with match string at end: Here it is!",13,10,0
  SzResult1      db 13,10,"Search Test 1 - value expected 37",13,10,0

  ; matchlen 17, sourcelen 1024
  ; deliberately difficult, every position must be tested with this match start
  SzMatch2       db "MMMMMMhardMMMMMMM"
  SzTest2        db 1007 dup ("M"), "MMMMMMhardMMMMMMM", 0
  SzResult2      db 13,10,"Search Test 2 - value expected 1007",13,10,0

  ; matchlen 16, sourcelen 1024
  ; pattern very different from background
  SzMatch3       db "Should be easier"
  SzTest3        db 1008 dup ("M"), "Should be easier", 0
  SzResult3      db 13,10,"Search Test 3 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch seems to have advantage for longer match lengths 
  SzMatch4       db "Many repetitions"
  SzTest4        db 72 dup ("Many repetitio"), "Many repetitions", 0
  SzResult4      db 13,10,"Search Test 4 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch can't seem to take advantage of the earlier match failure 
  SzMatch5       db "Many repetitions"
  SzTest5        db 72 dup ("Many repeatsns"), "Many repetitions", 0
  SzResult5      db 13,10,"Search Test 5 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; serious disadvantage for Boyer-Moore for this close repeating pattern
  ; as all the repeats must check from the matching end almost to the start
  SzMatch6       db "Many repetitions"
  SzTest6        db 72 dup ("No repetitions"), "Many repetitions", 0
  SzResult6      db 13,10,"Search Test 6 - value expected 1008",13,10,0

  ; matchlen 14, sourcelen 1024
  ; more random text, BInStrWithLen catching up with Boyer-Moore
  SzMatch7       db "no repetitions"
  SzTest7        db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text, few or no repetitions", 0
  SzResult7      db 13,10,"Search Test 7 - value expected 1009",13,10,0

.data?

align 16

  ShiftTable     DWORD 256 DUP (?)

.code

Start:
	Invoke	Main
	Invoke	ExitProcess, 0


Main    proc

        push    ebx
        push    edi
        mov     eax, input("Please terminate any high-priority tasks and press ENTER to begin...")
        print   chr$(13,10,13,10,"String search tests:",13,10,13,10)


        print   addr SzResult1

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult2

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult3

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult4

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult5

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult6

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult7

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        mov     eax, input(" Press ENTER to exit...")
        pop     edi
        pop     ebx
        ret

Main	EndP

; ------------------------------------------------------------------------------

align 16

FJT2	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Also restricted search string
            to 255 chars, allowing byte-length shifts and a 256-byte shift table.

            On entry:
                EAX = match_len (must be >= 2 and < 255)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, 254                ; string too long, must be < 254
        ja      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosb                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     BYTE PTR ShiftTable[ecx], al
        sub     al, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        movzx   ecx, BYTE PTR ShiftTable[ecx]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT2 endp

; ------------------------------------------------------------------------------

align 16

FJT3	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Also restricted search string
            to 64K chars, allowing word-length shifts and a 256-word shift table.

            On entry:
                EAX = match_len (must be >= 2 and < 65535)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, 65534              ; string too long, must be < 65535
        ja      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosw                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     WORD PTR ShiftTable[ecx+ecx], ax
        sub     ax, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        movzx   ecx, WORD PTR ShiftTable[ecx+ecx]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT3 endp

; ------------------------------------------------------------------------------

align 16

FJT4	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Full 4Gb string length searches
            possible with a DWORD-sized shift table.

            On entry:
                EAX = match_len (must be >= 2)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, MINUS_1            ; string too long, must be < 4Gb-1
        je      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosd                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     ShiftTable[ecx*4], eax
        sub     eax, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        mov     ecx, ShiftTable[ecx*4]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT4 endp

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

; ------------------------------------------------------------------------------

End	Start
